unit DAVSLColorForm_AddOns;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a VSL which shows a dialog with buttons for altering a
Shape's color.

2000-09-18 GW
------------------------------------------------------------}

//========================================
               interface
//========================================

// Nothing absolutely needs to be exposed

//========================================
             implementation
//========================================
uses SysUtils, classes, forms, Visio_TLB, DAVAO, DAVSL, DAVSL_Util, DAVSLColorForm_Form1;

Type
  //------------------------------
  TAddOnColorForm_Open = class(TAddOn)
  //------------------------------
  public
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
    function vlm_KILLSESSION (V2LRec: PVAOV2LRecord): TVAORC; virtual;
  end;

  //------------------------------
  TAddOnColorForm_Close = class(TAddOn)
  //------------------------------
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
  end;

  //------------------------------
  TAddOnColorForm_Beep = class(TAddOn)
  //------------------------------
    constructor Create;
    function vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC; override;
  end;


Var
  AddOnColorForm_Open  : TAddOnColorForm_Open ;
  AddOnColorForm_Close : TAddOnColorForm_Close;
  AddOnColorForm_Beep  : TAddOnColorForm_Beep;

//------------------------------
// AddOn Description .
//------------------------------

//------------------------------------------------------
constructor TAddOnColorForm_Open.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT {OR VAO_AOATTS_HASHELP OR VAO_AOATTS_WAITCRSR} , // atts
    VAO_ENABLEALWAYS     , // enabMask
    0                    , // invokeOnMask
    0                    , // notifyOnMask
    'DAVSLColorForm_Open'  , // lpName
    'Demo addon that opens a form to control shape color'
  );
end;

//------------------------------------------------------
function TAddOnColorForm_Open.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
begin
  Result := VAORC_SUCCESS;
  try
    If not Assigned(Form1) then
    Begin
      Form1 := TForm1.Create(Forms.Application, VSL.visApp, V2LRec^.wSessID);
      Form1.Show;
      Result := VAORC_L2V_MODELESS;
    end;
  except
    on E: Exception do
    Begin
      ErrorMessage('Error: ' + E.Message);
      Form1.Free;
      Form1 := nil;
    end;
  end;
end;

//------------------------------------------------------
function TAddOnColorForm_Open.vlm_KILLSESSION(V2LRec: PVAOV2LRecord): TVAORC;
//------------------------------------------------------
begin
  Result := VAORC_SUCCESS;   
  If Assigned(Form1) then
  Begin
    if Form1.SaveSessID = V2LRec^.wSessID then
    Begin
      Form1.Close;
    end;
  end;
end;

{ TAddOnShapeChange_Angle }

//------------------------------------------------------
constructor TAddOnColorForm_Close.Create;
//------------------------------------------------------
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT  , // atts
    VAO_ENABLEALWAYS     , // enabMask
    0                    , // invokeOnMask
    0                    , // notifyOnMask
    'DAVSLColorForm_Close'  , // lpName
    'Closes demo color form'
  );
end;

//------------------------------------------------------
function TAddOnColorForm_Close.vlm_RUN(V2LRec: PVAOV2LRecord; Args: TStringList): TVAORC;
//------------------------------------------------------
begin
  try
    If Assigned(Form1) then
    Begin
      Form1.Close;
    end;
    Result := VAORC_SUCCESS;
  except
    on E: Exception do ErrorMessage('Error: ' + E.Message);
  end;
end;

{ TAddOnColorForm_Beep }

constructor TAddOnColorForm_Beep.Create;
begin
  inherited Create(
    VAO_AOATTS_ISACTION OR VAO_AOATTS_HASABOUT  , // atts
    VAO_ENABLEALWAYS     , // enabMask
    0                    , // invokeOnMask
    0                    , // notifyOnMask
    'DAVSLColorForm_Beep'  , // lpName
    'Demo beep'
  );
end;

function TAddOnColorForm_Beep.vlm_RUN(V2LRec: PVAOV2LRecord;   Args: TStringList): TVAORC;
begin
  Beep;
  Beep;
  Beep;
end;

initialization
  //-------------------------------------------------------------
  // Creates object for this AddOn, and Enlists it with GWVAO_Mgr
  //-------------------------------------------------------------
  AddOnColorForm_Open  := TAddOnColorForm_Open.Create ;
  AddOnColorForm_Close := TAddOnColorForm_Close.Create;
  AddOnColorForm_Beep  := TAddOnColorForm_Beep.Create;
end.

