unit DAVSLEvents_Form;
{-----------------------------------------------------------
Demo of DAVSL VSL Framework
www.diagramantics.com

Demonstrates a VSL which monitors events and reports them to a
VSL window.

2000-09-20 GW
------------------------------------------------------------}

//=================================================
                 interface
//=================================================

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  //---------------------------------------------------
  // Normal Form class as created and managed by Delphi
  //---------------------------------------------------
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    bt_Clear: TButton;
    bt_EventsOn: TButton;
    bt_EventsOff: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bt_ClearClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bt_EventsOnClick(Sender: TObject);
    procedure bt_EventsOffClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//=================================================
                implementation
//=================================================
{$R *.DFM}
uses  DAVAO, DAVSL, DAVSLEvents_Control;

//------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
//------------------------------------------------------
begin
end;

//------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
//------------------------------------------------------
begin
  Action := caFree;
  EventController.DisableEventMonitoring;
  Form1 := nil; // to signal it doesn't exist
end;

//------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
//------------------------------------------------------
begin
  EventController.DisableEventMonitoring;
  Form1 := nil; // to signal it doesn't exist
end;

//------------------------------------------------------
procedure TForm1.bt_ClearClick(Sender: TObject);
//------------------------------------------------------
begin
  Memo1.Lines.Clear;
end;

//------------------------------------------------------
procedure TForm1.bt_EventsOnClick(Sender: TObject);
//------------------------------------------------------
begin
  EventController.EnableEventMonitoring;
  Memo1.Lines.Add('Watching Connections Added and Deleted');
end;

//------------------------------------------------------
procedure TForm1.bt_EventsOffClick(Sender: TObject);
//------------------------------------------------------
begin
  EventController.DisableEventMonitoring;
  Memo1.Lines.Add('Stopped watching connections.');
end;

end.

